"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.hasOwnProperties = exports.apiRequest = exports.jsonContentTypes = undefined;

var _tslib = require("tslib");

var tslib_1 = _interopRequireWildcard(_tslib);

var _rxjsImports = require("./rxjs-imports");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

var jsonContentTypes = exports.jsonContentTypes = ["application/json", "application/vnd.api+json"];
var apiRequest = exports.apiRequest = function (url, options) {
    if (options === void 0) {
        options = {};
    }
    return _rxjsImports.Observable.ajax(tslib_1.__assign({ url: url }, options, { responseType: "json" })).map(function (res) {
        if (res.status >= 200 && res.status < 300) {
            if (res.status === 204) {
                return res;
            }
            var header_1 = res.xhr.getResponseHeader("Content-Type");
            if (typeof header_1 === "string" && jsonContentTypes.some(function (contentType) {
                return header_1.indexOf(contentType) > -1;
            })) {
                return res.response;
            }
        }
        return res;
    });
};
var hasOwnProperties = exports.hasOwnProperties = function (obj, propertyTree) {
    if (obj instanceof Object === false) {
        return false;
    }
    var property = propertyTree[0];
    var hasProperty = obj.hasOwnProperty(property);
    if (hasProperty) {
        if (propertyTree.length === 1) {
            return hasProperty;
        }
        return hasOwnProperties(obj[property], propertyTree.slice(1));
    }
    return false;
};
//# sourceMappingURL=utils.js.map